package mobile.model.restapi.fiftech;

import mobile.model.datatype.Incidents1Object;
import mobile.model.datatype.IncidentsObject;
import mobile.model.datatype.ItemsObject;

import mobile.model.restapi.FiftechPath;

import mobile.model.restapi.fiftech.incidents.IdPath;

import oracle.eclipse.tools.rest.runtime.restapi.Action;
import oracle.eclipse.tools.rest.runtime.restapi.HTTPMethod;
import oracle.eclipse.tools.rest.runtime.restapi.Header;
import oracle.eclipse.tools.rest.runtime.restapi.Output;
import oracle.eclipse.tools.rest.runtime.restapi.PathObject;
import oracle.eclipse.tools.rest.runtime.restapi.PathValue;
import oracle.eclipse.tools.rest.runtime.restapi.QueryParameter;
import oracle.eclipse.tools.rest.runtime.restapi.Representation;
import oracle.eclipse.tools.rest.runtime.restapi.RequestAccessor;
import oracle.eclipse.tools.rest.runtime.restapi.RequestException;

/**
 * Interface generated for the 'incidents' path defined on the REST Service file:
 * /OEPE FiF IncidentReport 1.0 definition.xmi (last modified: 2015-09-24 09:56:37.322)
 */
@PathValue(value="incidents")
public interface IncidentsPath extends PathObject {
  @RequestAccessor
  public static interface Request {
    @Action(HTTPMethod.GET)
    @Header(name="Accept", value="application/json")
    @QueryParameter(name="technician", value="joe@fixit.com")
    @Output(representations=@Representation(type=IncidentsObject.class))
    IncidentsObject getIncidents() throws RequestException;

    @Action(HTTPMethod.POST)
    @Header(name="Content-Type", value="application/json")
    @Header(name="Accept", value="application/json")
    @Output(representations=@Representation(type=ItemsObject.class))
    ItemsObject postIncidents(
      @Representation(type=Incidents1Object.class) Incidents1Object incidents1) throws RequestException;
  }
  
  @Override
  FiftechPath parent();

  /**
   * @return creates a new object that exposes the requests
   *         defined for this path
   */
  Request invoke();

  /**
   * @param id the value for the path parameter '{id}' defined on the REST API.
   *        If this object is not <code>null</code>, it will be converted to a string using its {@link #toString()} method.
   *        If it is <code>null</code>, an empty string is used instead.
   * @return the child {@link IdPath}
   */
  IdPath getIdPath(String id);
}
